#!/usr/bin/ruby -w

# Scotty TNG - ping/snmp based realtime network monitoring
#
# $Id: dumpts.rb 147 2008-10-21 12:36:35Z liske $
#
# Authors:
#   Thomas Liske <liske@ibh.de>
#   Andre Ellguth <ellguth@ibh.de>
#
# Copyright Holder:
#   2008 (C) IBH IT-Service GmbH [http://www.ibh.de/apt-dater/]
#
# License:
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this package; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
#
# Small debug script dumping the content of a tuple space.
#

require 'drbfire.rb'
require 'rinda/ring'

len = $*.shift.to_i

len = 4 unless len > 0

## Connect to tuple space
DRb.start_service
begin
    ts = Rinda::RingFinger.primary
rescue
    puts "Could not connect to ring server: #{$!}"
    exit 1
end
puts "Dumping #{ts.__drburi}:"

items = ts.read_all(Array.new(len, nil))
items.each{ |i|
    p i
}
