module Xen
  class VBD < Base

    @initial_config = {
#      :device=>"hda1", 
      :bootable=>"0", 
      :mode=>"RW", 
      :type=>"disk", 
      :driver=>"paravirtualised",
#      :VM => "73a2c34f-d5f1-2c96-e6f6-ca98de793d2d", 
#      :VDI => "20b1af7c-fe3a-bdf4-eeb8-c8635d0daadc"
    }

    # Creates a new VBD. Required paramters are the device ('hda1'), the vm object, the vdi object and the host
    def self.create(dev, vm, vdi, host)
      o = @initial_config.merge({:device => dev, 
                                      :VM => vm.uuid,
                                      :VDI => vdi.uuid})
      uuid = host.get_value("VBD.create", o)
      self.new(uuid, host)
    end
    
    # Gets the connected VDI
    def vdi
      Xen::VDI.new(@host.get_value('VBD.get_VDI', self.uuid), @host)
    end
    
    # Destroys the VBD
    def destroy!
      @host.call('VBD.destroy', self.uuid)
    end
    
    # Gives a nice description
    def humanize
      r = self.record
      "VBD #{self.uuid} is disk '#{r['device']}' in the VM, connected to VDI #{self.vdi}\n" + self.vdi.humanize('\--')
    end
  end
end