
require 'rexml/document'
require 'gtk2'

class EditorObjects
  def initialize(file_name)
    return nil if File.readable?(file_name) == false

    @objects = load_objects(file_name)
  end

  def to_widget(name)
    @objects.each { |obj|
      if obj["name"] == name then
	w = Gtk::EventBox.new
	image = Gtk::Image.new("res/" + obj["image"])
	w.add(image)

	return w
      end
    }

    return nil
  end

  def to_icon(name)
    
  end

  def load_objects(file_name)
    f = File.new(file_name)
    str = String.new
    begin
      while (line = f.readline)
	str << line.chomp
      end
    rescue EOFError
      f.close
    end

    xml = REXML::Document.new(str)

    objects = Array.new
    xml.elements.each("/objects/*") { |obj|
      a = Array.new
      obj.elements.each { |attr|
	a.push(
	       {"name" => attr.attributes["name"], 
		 "descr" => attr.attributes["descr"]})
      }
      objects.push( 
	{"name" => obj.attributes["name"], "descr" => obj.attributes["descr"],
		     "image" => obj.attributes["image"], "attr" => a})
      
     
    }

    return objects
  end
 
end
